#!/bin/sh

# installation file for guard 2.6
# (c) Ondrej Suchy <ondrej.suchy@underground.cz>
# read http://underground.cz and stay alive!

cat << EOF

this installation file is pre-alpha version!
it's simple set of commands with default settings and without error checking.
it may help you install guard on fresh system. do not use it to upgrade
from older versions. and do not use it if you don't want default
configuration. when some problems occurs, please read the source code of
this script to know what has been done and how to reverse it.
to prove you have read and understood this now write the 26th word from the
beggining.
EOF
echo -n ": "; read WORD
if [ ! "$WORD" = "fresh" ]; then
  echo "sorry. bad one"
  exit 1
fi

echo "making directory /usr/guard"
mkdir /usr/guard
echo "adding user guard"
#adduser guard

echo "changing shell for user guard to /bin/false"
#chsh guard -s /bin/false

echo "copying files"
cp -dpR bin /usr/guard
cp g /usr/guard
cp httpd_logger /usr/guard
cp -dpR rules/ /usr/guard
cp guard.conf /usr/guard
mkdir /usr/guard/tmp

echo "creating logging FIFO"
mkfifo /usr/guard/logfifo

echo "creating logfile /var/log/security"
touch /var/log/security

echo "assigning permissions"
chmod o= -R /usr/guard
chown root.root -R /usr/guard

chown root.guard /usr/guard
chmod u=rx,g=rx /usr/guard

chown root.guard -R /usr/guard/rules
chmod g=rx /usr/guard/rules
chmod g=r /usr/guard/rules/*

chmod u+x /usr/guard/g
chmod u+x /usr/guard/httpd_logger

chgrp guard /usr/guard/logfifo
chmod g=r /usr/guard/logfifo

chgrp guard /usr/guard/tmp
chmod g=wx /usr/guard/tmp

chgrp guard /dev/tty12
chmod g+w /dev/tty12

chgrp guard /var/log/security
chmod g+w /var/log/security

echo "adding line to /etc/syslog.conf"
echo "*.*							|/usr/guard/logfifo" >> /etc/syslog.conf


echo
echo "*** done"
echo "guard is installed in directory /usr/guard"
echo
echo "these steps have to be done manually now:"
echo "1. edit /usr/guard/guard.conf and set all variables that have to be set"
echo "2. put /usr/guard/g to startup scripts"
echo "  WARNING: system lockup occurs when syslogd starts writing to FIFO
          and there's no guard process to read from it. always start guard
          before syslogd!"
echo "3. start guard and killall -HUP syslogd"
